var Class = require("../class/Class.js").Class;
var Types = require("../common/Types.js");
var compress = require('compress-buffer').compress;
var uncompress = require('compress-buffer').uncompress;


var Compressor = function(){

    this._configuration = null;
    
    this.initialize = function(configuration){
       this._configuration = configuration;
    };
    
    this.compress = function(data, callback, compressLevel){
        compressLevel = compressLevel || 6;
        var compressedData = compress(data, compressLevel);
        callback(
            compressedData,
            this._getCompressionRate(data.length, compressedData.length)
        );
    };
    
    this.uncompress = function(data, callback){
        var compressedData = uncompress(data);
        callback(
            compressedData,
            this._getCompressionRate(data.length, compressedData.length)
        );
    }
    
    
    this._getCompressionRate = function(unCompressedLength, compressedLength){
        return {
            times: Math.round(unCompressedLength/compressedLength),
            percentage: Math.round((100-(100*(compressedLength/unCompressedLength)))),
            compressedLength: compressedLength,
            unCompressedLength: unCompressedLength
        };        
    };
    
};
Compressor = new Class( new Compressor() );
exports.Compressor = Compressor;    